
import java.awt.*;

public class AddHostDialog extends Dialog
{
MTool parent;
	public AddHostDialog(MTool parent, boolean modal)
	{
		super((Frame) parent, modal);
		this.parent = parent;

		//{{INIT_CONTROLS


  setLayout(null);
                setVisible(false);
                setSize(insets().left + insets().right + 281,insets().top + insets().bottom + 224);
                setBackground(new Color(-8415569));
                textField1 = new java.awt.TextField();
                textField1.setBounds(insets().left + 128,insets().top + 93,125,26);
                textField1.setFont(new Font("Dialog", Font.PLAIN, 10));
                textField1.setBackground(new Color(16777215));
                add(textField1);
                label1 = new java.awt.Label("IP Address",Label.RIGHT);
                label1.setBounds(insets().left + 28,insets().top + 93,87,25);
                add(label1);
                label2 = new java.awt.Label("OS type",Label.RIGHT);
                label2.setBounds(insets().left + 33,insets().top + 127,82,25);
                add(label2);
                choice1 = new java.awt.Choice();
                choice1.addItem("Linux");
                choice1.addItem("Solaris");
                choice1.addItem("HP-UX");
                choice1.addItem("Windows");
		add(choice1);
                choice1.setBounds(insets().left + 128,insets().top + 120,90,40);
                button1 = new java.awt.Button();
                button1.setActionCommand("button");
                button1.setLabel("OK");
                button1.setBounds(insets().left + 63,insets().top + 180,51,24);
                button1.setBackground(new Color(12632256));
                add(button1);
                button2 = new java.awt.Button();
                button2.setActionCommand("button");
                button2.setLabel("Cancel");
                button2.setBounds(insets().left + 167,insets().top + 181,51,24);
                button2.setBackground(new Color(12632256));
                add(button2);
                textField2 = new java.awt.TextField();
                textField2.setBounds(insets().left + 127,insets().top + 59,125,26);
                textField2.setFont(new Font("Dialog", Font.PLAIN, 10));
                textField2.setBackground(new Color(16777215));
                add(textField2);
                label3 = new java.awt.Label("Nickname",Label.RIGHT);
                label3.setBounds(insets().left + 34,insets().top + 59,80,25);
                add(label3);
                label4 = new java.awt.Label("Enter host information",Label.CENTER);
                label4.setBounds(insets().left + 13,insets().top + 15,255,27);
                add(label4);
                setTitle("Add Host");

		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		//}}
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public AddHostDialog(MTool parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public synchronized void show()
	{
		Rectangle bounds = getParent().bounds();
		Rectangle abounds = bounds();

		move(bounds.x + (bounds.width - abounds.width)/ 2,
			 bounds.y + (bounds.height - abounds.height)/2);

		super.show();
	}

	//{{DECLARE_CONTROLS
	java.awt.TextField textField1;
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.Choice choice1;
	java.awt.Button button1;
	java.awt.Button button2;
  java.awt.TextField textField2;
  java.awt.Label label3;
java.awt.Label label4;

	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == AddHostDialog.this)
				Dialog1_WindowClosing(event);
		}
	}
	
	void Dialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_Action(event);
			else if (object == button2)
				button2_Action(event);
		}
	}

	void button1_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
	  if (textField1.getText() != "")
	    {
	      //("Dodal host "+textField1.getText()+ "  OS: "+ choice1.getSelectedItem()+" NIck "+textField2.getText());
	      new AddHost(textField1.getText(),choice1.getSelectedItem(),textField2.getText());
	      parent.get_all_hosts();
	      dispose();
	    }
	}

	void button2_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Select all of the text
	  //textField1.selectAll();
		//}}
	  dispose();
	}
}
