import java.net.*;
import java.io.*;
import java.awt.*;
import java.util.*;

class CompThread extends Thread {
   
   protected String comp_name;
   protected CompFrame comp_frame ;
   private  GetData client;
   private  String line;
   private  float value = 0;
   private  String name;
   private  String name1;
   private  String next_word;
   Info info = new Info();
   DataInfo dinfo ;
   boolean first_time = true;
   boolean info_first = true;
   boolean debug = false;   
  CompInfo parent;
  boolean run = true;
  
  protected CompThread(CompInfo c,String name) 
    {
      parent = c;
      comp_frame = new CompFrame(name, info,this);
      comp_name=name;
      //comp_frame.show();
      //setDaemon(true);
      this.start();
      
  }
   
public synchronized void run() 
     {
	for(;;) 
	  {
	     
	     try
	       {
		 /******************************************/
		  client = new GetData(Preferences.getServerName(),Preferences.getServerPort());
	       }
	     catch (IOException e )
	       {
		  Messages.addText("There was an error tryin to connect to server ");
	       }
	     for(;;)
	       {
		 if (run)
		   {
		  if (info_first)
		    {
		       get_list();
		       if(debug)Messages.addText ( "GET LIST "+ info.size());
		       comp_frame.init_vector();
		    }
		  else
		    {
		       if(first_time)
			 {
		       get_hist();
			 }
		       else
			 {
			    get_actual();
			 }
		    }
		  
		  if (!first_time && !info_first) 
		    {	
		       
		       try  
			 { 
			   /**************************/
			   
			    this.sleep(Preferences.getRefreshTime()*1000);
			 } 
		       catch (InterruptedException e) { ; }
		    }
		  comp_frame.redraw();
		  comp_frame.clear_text();
		  comp_frame.show_text();
		  comp_frame.reset_text();
		  if (client == null )
		    {
		  
		       break;
		    }
		   }
	       }
	  }
	
     }
   
   
public void get_hist ()
     {
	boolean konec =false ;
	
	if (first_time)
	       {
		  if (client.isConnected())
		    {
		       if (client != null)
			 {
//			    line = client.get_line();
//			    line = client.get_line();
			    client.write("COMP_HIST");
			    client.write(comp_name);
			    //client.write("bye");
			    while ( ( line = client.get_line()) != null)
			      {
				 //Messages.addText("Dobilv get_hist : " + line);
				 if( line.equalsIgnoreCase("false"))
				   {
				      comp_frame.state(false);
				      set_false_state(comp_name);
				      Messages.addText("Setting to false"+ comp_name);
				   }
				 else
				   {
				      comp_frame.state(true);
				      int element_counter = 0 ;
				      StringTokenizer st = new StringTokenizer(line,"|");
				      while ( st.hasMoreTokens())
					{
					   next_word =st.nextToken();
					   if ( next_word.equalsIgnoreCase("GRAPH") )
					     {
						name =  st.nextToken();
						value =  Float.valueOf(st.nextToken()).floatValue();
						comp_frame.add_data(name, value);
						element_counter++;
					     }
					   else
					     if ( next_word.equalsIgnoreCase("VALUE") )
					     {             
						name =  st.nextToken();
						name1 =  st.nextToken();
						comp_frame.add_mem(name,name1);
					     }
					   else
					     if ( next_word.equalsIgnoreCase("PROCESS") )
					     {
						name = st.nextToken();
						name1 = st.nextToken();
						if ( name1.equalsIgnoreCase("false"))
						  {
						     name = name+"   Not Working!\n";
						     comp_frame.add_data_list(name);
						     comp_frame.problems();
						     //process_frame.list.setForeground(Color.black);
						  }
						else
						  {
						     name = fill(name,11);
						     name1 = fill(name1,7);
						     name = name + name1 ;
						     name1 = st.nextToken();
						     name1 = fill(name1,7);
						     name = name + name1;
						     name1 = st.nextToken();
						     name1 = fill(name1,7);
						     name = name + name1;
						     comp_frame.add_data_list(name);
						  }
					     }
					   else
					     if( next_word.equalsIgnoreCase("END") )
					     {
						konec = true;
						break;
					     }
					   
					}
				      
				   }
				 if (konec) break ;
			      }
			 } 
		       first_time = false;
		    }
		  comp_frame.redraw();
		  //client.disconnect();
		  //client = null;
	       }
	comp_frame.rearange();
	comp_frame.redraw();

     }
   
	
	

   public void get_actual ()
     {
	boolean konec = false;
	
	if (client.isConnected())
	  {
	     if (client != null)
	       {
//		  line = client.get_line();
//		  line = client.get_line();
		  client.write("COMP");
		  client.write(comp_name);
		 // client.write("bye");
		  comp_frame.reset_list();
		  //Messages.addText("Should get new data");
		  while ( ( line = client.get_line()) != "_END_")
		    {
		       if( line.equalsIgnoreCase("false"))
			 {
			    comp_frame.state(false);
			    set_false_state(comp_name);
			    Messages.addText("Setting to false"+ comp_name);
			 }
		       else
			 {
			    comp_frame.state(true);
			    int element_counter = 0 ;
			    StringTokenizer st = new StringTokenizer(line,"|");
			    while ( st.hasMoreTokens())
			      {
				 next_word =st.nextToken();
				 if ( next_word.equalsIgnoreCase("GRAPH") )
				   {
				      name =  st.nextToken();
				      value =  Float.valueOf(st.nextToken()).floatValue();
				      comp_frame.add_data(name, value);
				      element_counter++;
				   }
				 else
				   if ( next_word.equalsIgnoreCase("VALUE") )
				   {             
				      name =  st.nextToken();
				      name1 =  st.nextToken();
				      comp_frame.add_mem(name,name1);
				   }
				 else
				   if ( next_word.equalsIgnoreCase("PROCESS") )
				   {
				      name = st.nextToken();
				      name1 = st.nextToken();
				      if ( name1.equalsIgnoreCase("false"))
					{
					  CompVector.setProcessToFalse(comp_name);
					   comp_frame.add_pa("\t"+name + "\tNot Working\n");
					}
				      else
					{
					   name += "\t"+name1+"\t";
					   name += "  "+st.nextToken()+"\t"; 
					   name += st.nextToken()+"\t\n"; 
					   comp_frame.add_pa( name );
					   
					}
				   }
				 else 
				   if ( next_word.equalsIgnoreCase("END") )
				   {
				      konec = true;
				      break;
				   }
				 else 
				   if ( next_word.equalsIgnoreCase("USER") )
				   {
				      name = "";
				      name += st.nextToken()+"\t";
				      name += st.nextToken()+"\t";
				      name += st.nextToken()+"\t";
				      name += st.nextToken();
				      name += "\t\t"+st.nextToken()+"\n";
				      comp_frame.add_ua( name );
				      //Messages.addText(name);
				   }
				 else 
				   if ( next_word.equalsIgnoreCase("DISK") )
				   {
				      name = "";
				      name1 = st.nextToken();
				      if ( name1.length() < 8)
					name1+="\t\t";
				      else
					name1+="\t";
					
				      name += name1;
				      name += st.nextToken()+"\t";
				      name += st.nextToken()+"\t";
				      name1 = st.nextToken();
				      if (name1.length() > 5)
				      name1 = name1.substring(0,5);
				      name += name1+"\t";
				      name += st.nextToken();
				      name += "\t"+st.nextToken()+"\n";
				      comp_frame.add_da( name );
				      if(debug)Messages.addText(name);
				   }
			      }
			 }
		       if (konec) break ;
		    }
	       }
	  }
     }
   
	
	
   public void get_list()
     {
	boolean konec = false;

	if(debug)Messages.addText("V get_list()");
	if (client.isConnected())
	  {
	     if (client != null)
	       {
		  line = client.get_line();
		  line = client.get_line();
		  client.write("comp");
		  client.write(comp_name);
		  //client.write("bye");
		  while ( (( line = client.get_line()) != null) && (!konec) )
		    {
		       //Messages.addText("Dobil : " + line);
		       int element_counter = 0 ;
		       StringTokenizer st = new StringTokenizer(line,"|");
		       while ( st.hasMoreTokens())
			 {
			    next_word =st.nextToken();
			    if ( next_word.equalsIgnoreCase("GRAPH") )
			      {
				 name =  st.nextToken();
				 value =  Float.valueOf(st.nextToken()).floatValue();
				 //Messages.addText("Ading " + name);
				 if (info_first)
				   info.add_data(name, true);
				 element_counter++;
			      }
			    else
			      if (next_word.equalsIgnoreCase("END"))
			      {
		
				 konec = true;
				 break;
			      }
			 } 
		  
		       if(konec) break ;
		       info_first = false;
		    }
		  
		  comp_frame.redraw();
		  //client.disconnect();
		  //client = null;	     
	       }
	  }
	comp_frame.fill_vect();
	comp_frame.get_a();
     }
   
   

	
   
	
	
	
	
   
   
   
String fill( String s, int i)
     {
    while (s.length() != i)
      s= s+" ";
    return s;
  }
  
  public void close_all()
    { 
      //run = false;
        
  }

  void set_false_state(String n)
    {
      CompInfo tmp;
       for ( int i = 0; i < CompVector.size(); i++)
	 {
            tmp = (CompInfo) CompVector.elementAt(i);
            if (tmp.getHost().equalsIgnoreCase(n))
	      {
		tmp.setState(false);
		CompVector.setElementAt(tmp,i);
	      }
        }
      Messages.addText("Setting "+n+" to false"); 
    }


  public void windowClose()
    {
      parent.setWindowClose();
    }


}

