import java.awt.*;
import java.util.*;


public class GraphPanel extends Panel
{
   Info info ;
   DataInfo dinfo;
   GraphCanvas gc = new GraphCanvas("Name");
   GraphCanvas gc1 = new GraphCanvas("Name");
   Vector vector = new Vector ();
   Vector canvas_vect = new Vector ();
   boolean state = false;
    boolean debug = false;
   
   public GraphPanel ( )
     {
	
	
     }

   
   public GraphPanel ( Info inf)
     {
	info = inf;
	setLayout ( new FlowLayout());
	
     }

   /**Initializes Vector of Graphs*/
   
    public void init_vector ()
     {
	GraphCanvas gc ;
	DataInfo di ;
       
	if (debug) System.out.println("\0007 V INIT Vektor : "+ info.size());
	for ( int i = 0; i < info.size(); i++)
	  {
	     di = info.get_info(i);
	     gc = new GraphCanvas ( di.getName());
	     vector.addElement(gc);
	     if(debug) System.out.println(" V INIT Vektor : "+ di.getName());
	  }
	rearange();
     }
   
/**Adds data to Graphs*/
   
   public void add_data (String name ,float value)
     {
	GraphCanvas gc;
	
	for ( int i = 0 ; i < vector.size(); i++)
	  {
	     gc = (GraphCanvas) canvas_vect.elementAt(i);
	     if (name.equalsIgnoreCase(gc.get_name()))
	       {
		  if ((name.indexOf("avg") >= 0))
		    gc.add_data( (int) (value*25));
		  else
		    gc.add_data( (int) (value));
		  vector.setElementAt(gc,i);
		  // System.out.println("Added  "+name + " : "+value);
	       }
	  }
     }

   /**Redraws all Graphs*/
   public void redraw()
     {
	GraphCanvas gc;
	for ( int i = 0 ; i < vector.size(); i++)
	  {
	     gc = (GraphCanvas) canvas_vect.elementAt(i);
	     gc.redraw();
	  }
	validate();
     }

/**Rearange Graphs*/
    public void rearange ()
     {	
	GraphCanvas gc ;
	
	removeAll();
	for ( int i = 0; i < vector.size(); i++)
	  {
	     gc = (GraphCanvas) vector.elementAt(i);
	     if ( gc.get_state())
	       {
		  //System.out.println("risem "+gc.get_name());
		  add ( (GraphCanvas) vector.elementAt(i));
		  gc.resize (gc.preferredSize());
		  // System.out.println("k vrsta " + 100*(k%2)+"j vrsta"+100*(j%2));
		  gc.redraw();
	       }
	     
	  }
	validate();
     }
   
   /**set state of Computer*/
   public void state (boolean b)
     {
	state = b;
     }
   
   
 /**Returns state of Computer*/  
   public boolean get_state()
     {
	return state;
     } 

    public void get_a()
     {
	GraphCanvas gc;
	
	for ( int i = 0 ; i < canvas_vect.size(); i++)
	  {
	     gc = (GraphCanvas) canvas_vect.elementAt(i);
	     //System.out.println("Canvas na "+ i+ " ima ime "+gc.get_name());
	  }
     }
  public void fill_vect ()
     {
	for ( int i = 0 ; i < info.size(); i++)
	  {
	     dinfo = info.get_info(i);
	     canvas_vect.addElement( new GraphCanvas(dinfo.getName()));
	  }
	
	
     }



   
}

	
   
   


