import java.awt.*;
import java.util.*;

class ImageCanvas extends java.awt.Canvas
{
    Hashtable hashTable;
    Image im1;
    Image im2;
    Image im3;    
    Vector compVector = new Vector();
    Dimension d;
    int X;
    boolean first = false;
    
    ImageCanvas ()
    {
        
        d = this.getSize();
        X = d.width;
		//{{REGISTER_LISTENERS
		SymMouse aSymMouse = new SymMouse();
		this.addMouseListener(aSymMouse);
		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);
		//}}
		
	}
    
    public void update(Graphics g)
    {
        paint(g);
    }
    
    public void paint(Graphics g)
    {
        CompInfo tmp;
        d = this.getSize();
        X = d.width;
	if (first)    g.fillRect(0,0,300, 400);
	 if ( first) rearange();
       /* g.setColor(Color.black);
        if(im1 != null)g.drawImage(im1, 10,40,this);
        if(im2 != null)g.drawImage(im2, 70,40,this);
        if(im3 != null)g.drawImage(im3, 130,40,this);
        g.drawRect(10,10,60,60);*/
        g.setColor(new Color (127,150,175));
        g.fillRect(0,0,d.width, d.height);
        g.setColor(Color.black);
        for ( int i = 0; i < CompVector.size(); i++)
        {
            tmp = (CompInfo) CompVector.elementAt(i);
            tmp.paint(g, this);
        }
    }
    
    public void pass_ht(Hashtable ht)
    {
        hashTable = ht;
        im1 = (Image) hashTable.get("linux");
        im2 = (Image) hashTable.get("sun");
        im3 = (Image) hashTable.get("hp");
   
    }
    
public void rearange()
{
        CompInfo tmp;
        int y = 10;
        int x = 0;
        for ( int i = 0; i < CompVector.size(); i++)
        {
            tmp = (CompInfo) CompVector.elementAt(i);
            if ( (x*90+90 > X))
            {
              y+=40;
              x = 0;
            }
	    tmp.setX(x*90+5);
	    tmp.setY(y);
	    x++;
            CompVector.setElementAt(tmp, i);
        }
        first = false;
        repaint();
}
    public void pass_comp(Vector v)
    {

        compVector = v;
        repaint();
        first = true;
    }
    
    
	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == ImageCanvas.this)
				ImageCanvas_MousePress(event);
		}

		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == ImageCanvas.this)
				ImageCanvas_MouseClick(event);
		}
	}

	void ImageCanvas_MouseClick(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	   
        clickInside(event.getX(), event.getY());	    
	}

	void ImageCanvas_MousePress(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		
	}
	
	
	private void clickInside(int x, int y)
	{
        CompInfo tmp;
        for ( int i = 0; i < CompVector.size(); i++)
        {
            tmp = (CompInfo) CompVector.elementAt(i);
            tmp.inBounds(x,y);
        }
        
        
    }

	class SymComponent extends java.awt.event.ComponentAdapter
	{
		public void componentResized(java.awt.event.ComponentEvent event)
		{
			Object object = event.getSource();
			if (object == ImageCanvas.this)
				ImageCanvas_ComponentResized(event);
		}
	}

	void ImageCanvas_ComponentResized(java.awt.event.ComponentEvent event)
	{
		// to do: code goes here.
	    rearange();
	}

  void setX(int a)
    {
      X = a;
    }


  public Dimension getPrefferedSize()
    {
      return new Dimension(300,300);
    }

}
