import java.net.*;
import java.io.*;
import java.awt.*;
import java.util.*;



class ValueCanvas extends Canvas
{
  Dimension d;
  int counter=0;
  String mem_real, mem_free, swap_real, swap_free = "";
  int MEM_real, MEM_free, SWAP_real, SWAP_free, num_proc = 1;
  int swap_total, mem_total = 1;
  FontMetrics fm;
  boolean state = true;
  boolean debug = false;

   public  ValueCanvas ()
     {
	
	setBackground( Color.blue);
	MEM_real = 20;
	MEM_free = 30;
	mem_total = 50;
	SWAP_real = 20;
	SWAP_free = 30;
	swap_total = 50;
	
	repaint();
    

  }
  
  public void paint (Graphics g)
  {
    int value1, value2 , temp;
    d=this.size();
    fm = g.getFontMetrics();
    g.setColor(Color.blue);
     g.fillRect(0,0,d.width,d.height);
    if (state)
      {
	try
	  {
	     
	     value1 = (int) (( (MEM_real-MEM_free)*200)/MEM_real);
	     g.setColor(Color.red);
	     g.fillRect( 0,20,value1,20);
	     g.setColor(Color.green);
	     value2 = (int) ((MEM_free*200)/MEM_real);
	     g.fillRect( 0+value1,20,value2,20);
	     g.setColor(Color.black);
	     g.drawString(""+((MEM_real-MEM_free))+" K",0,35);
	     temp = fm.stringWidth(""+(MEM_free)+" K");
	     g.drawString(""+(MEM_free)+" K",200-temp,35);
	     g.setColor(Color.white);
	     g.drawString("Memory",0,15);
	     
	     value1 = (int) (( (SWAP_real-SWAP_free)*200)/SWAP_real);
	     g.setColor(Color.red);
	     g.fillRect( 210,20,value1,20);
	     g.setColor(Color.green);
	     value2 = (int) ((SWAP_free*200)/SWAP_real);
	     g.fillRect( 210+value1,20,value2,20);
	     g.setColor(Color.black);
	     g.drawString(""+(( SWAP_real-SWAP_free))+" K",210,35);
	     temp = fm.stringWidth(""+(SWAP_free)+" K");
	     g.drawString(""+(SWAP_free)+" K",410-temp,35);
	     g.setColor(Color.white);
	     g.drawString("Swap",210,15);
	     
	  }
	catch ( ArithmeticException e) 
	  {}
      }
    else
      {
	g.setColor(Color.red);
	temp = fm.stringWidth("Not Available");
	g.drawString("Not Available",(d.width-temp)/2,60);
      }
  
  }
  
public void state (boolean b)
  {
    state = b;
    repaint();
  }

public boolean get_state()
  {
    return state;
  } 

public Dimension minimumSize()
  {
    return new Dimension (100 ,60 );
  }
 
public Dimension preferredSize ()
  {
    return minimumSize ();
  }



 public void update (Graphics g)
     {
	paint (g);
     }


public void add_data (String string, String dat)
  {
      if(debug) System.out.println("Added : "+ dat);
     if ( string.equalsIgnoreCase("MEM_real"))
       mem_real = dat;
     else
       if ( string.equalsIgnoreCase("MEM_free"))
	 mem_free = dat;
       else
	 if ( string.equalsIgnoreCase("MEM_swap"))
	   swap_real = dat;
	 else
	   if ( string.equalsIgnoreCase("MEM_swap_free"))
	     swap_free = dat;
	   else
	     if ( string.equalsIgnoreCase("NUM_PROC"))
	       num_proc = Integer.valueOf(dat).intValue();;
     
     
     if ( (swap_free != "" ) && (swap_real != "") && (mem_real != "") && (mem_free != "") )
       do_konversion ();
     
				
				
	 
     

     //    repaint();
  }

public void do_konversion ()
  {
   
    String temp ;
    char ch;
    int i;
/*
     System.out.println("mem real : "+mem_real);
     System.out.println("mem free : " +mem_free);
     System.out.println("swap real : "+swap_real);
     System.out.println("swap free : " +swap_free);
  */   
     if ( (ch = swap_free.charAt(swap_free.length()-1)) == 'M')
      {
	//	System.out.println(swap_free);
	temp = swap_free.substring(0,swap_free.length()-1);
	//System.out.println(temp);
	i = Integer.valueOf(temp).intValue()*1000;
	SWAP_free = i;
      }
    else
      {
//	System.out.println(swap_free);
	temp = swap_free.substring(0,swap_free.length()-1);
//	System.out.println(temp);
	i = Integer.valueOf(temp).intValue();
	SWAP_free = i;
      }


    if ( (ch = mem_free.charAt(mem_free.length()-1)) == 'M')
      {
	temp = mem_free.substring(0,mem_free.length()-1);
	i = Integer.valueOf(temp).intValue()*1000;
	MEM_free = i;
      }
    else
      {
	temp = mem_free.substring(0,mem_free.length()-1);
	i = Integer.valueOf(temp).intValue();
	MEM_free = i;

      }


    if ( (ch = swap_real.charAt(swap_real.length()-1)) == 'M')
      {
	
	temp = swap_real.substring(0,swap_real.length()-1);
	i = Integer.valueOf(temp).intValue()*1000;
	SWAP_real = i;
      }
    else
      {
	temp = swap_real.substring(0,swap_real.length()-1);
	i = Integer.valueOf(temp).intValue();
	SWAP_real = i;
      }


    if ( (ch = mem_real.charAt(mem_real.length()-1)) == 'M')
      {
	temp = mem_real.substring(0,mem_real.length()-1);
	i = Integer.valueOf(temp).intValue()*1000;
	MEM_real = i;
      }
    else
      {
	temp = mem_real.substring(0,mem_real.length()-1);
	i = Integer.valueOf(temp).intValue();
	MEM_real = i;
      }
    
    mem_total = MEM_real;
     
    swap_total = SWAP_real; 
/*
     
     System.out.println("mem real : "+MEM_real);
     System.out.println("mem free : " +MEM_free);
     System.out.println("swap real : "+SWAP_real);
     System.out.println("swap free : " +SWAP_free);
     

     System.out.println("TOTAL MEM : "+mem_total);
     System.out.println("TOTAL SWAP : " +swap_total);
     System.out.println("MEM real : "+MEM_real);
     System.out.println("MEM swap : " +MEM_free);
  */
  
  }

     
public void redraw()
  {
    repaint();
  }
    


}
