import java.io.*;



class CompData 
{
  private String lines [] = new String [40];
  private int lines_num = 0;
  static final String empty = "";
  private String comp_name ;
  private boolean active = false;
  private String os_type;
  private String nick;

  public CompData (String host)
  {
    comp_name = host;
  }
public CompData (String host,String t,String n)
  {
    comp_name = host;
    os_type = t;
    nick = n;
  }

  public void add_line(String line)
  {
    lines [lines_num] = line;
    lines_num++;
  }

  public int get_lines_num()
  {
    return lines_num-1;
  }
  
  public String get_line ( int num)
  {
    if ( num < lines_num)
      return lines[num];
    return empty;
  }
  
  public String get_name()
  {
    return comp_name;
  }

 public void set_name(String n)
  {
    comp_name =n ;
  }

public String get_OS_type()
    {
      return os_type;
    }

   public void write_all()
  {
    System.out.println(" All for NAME : "+ comp_name + ":"+os_type );
    for ( int i = 0; i< lines_num; i++)
      System.out.println(lines[i]);
  }

  public boolean isActive ()
  {
    return active;
  }
  
  public void setActive(boolean a)
  {
    active = a;
  }
  
  public  void reset()
  {
    lines_num =0;
  }

  public void set_nick(String n)
    {
      nick = n;
    }

public String get_nick()
    {
      return nick;
    }


}
      
