import java.net.*;
import java.io.*;
import java.util.*;

class ConfigFile
{

  public static FileOutputStream fout = null;
  public static FileInputStream  fin = null;
  public static DataInputStream fdatain = null;
  public static PrintStream fdataout = null;
  public static String niz;
  String fileName= "config";
  String hostName;
  public final int MAX_SIZE = 100;
  String lines[] = new String[MAX_SIZE];


  public ConfigFile()
    {
      
      
      if (fileName != null)
      {
	try   
	  {
	    fin = new FileInputStream (fileName);   
	    fdatain = new DataInputStream (fin);
	  }  
	catch (FileNotFoundException e){};

	
	try{
	  for (int i = 0; i < MAX_SIZE; i++)
	    lines[i] = fdatain.readLine();
	}
	catch (IOException e){};
	
	/*	for (int i = 0; i < lines.length; i++)
          if (lines[i] != null)
            System.out.println (lines[i]);
	*/
	try
	  {
	    fout = new FileOutputStream (fileName);
	    fdataout = new PrintStream (fout);
	  }
	catch (IOException e){};
	
      }

    }

  public void add(String hostName,String OS,String nick)
    {
      for (int i = 0; i < lines.length; i++)
	if (lines[i] != null)
	  {
	    fdataout.println (lines[i]);
	    if(i == 1)
	      fdataout.println(hostName+" "+OS+" "+nick);
	  }
      try
	{
	  fdataout.close();
	  fdatain.close();
	  fout.close();
	  fin.close();
	}
      catch (IOException e){};
     
      
      CompData COMP = new CompData(hostName,OS,nick) ; //changed when added OS type
      COMP.setActive(true);
      COMP.reset();
      COMP.set_nick(nick);
      Server.comp_vector.addElement(COMP); 
      CompHist HIST = new CompHist(hostName);
      Server.hist_vector.addElement(HIST);
      
    }

  public void  remove(String hostName, String OS,String nick)
    {
      String hn = hostName+" "+OS+" "+nick;
      
        for (int i = 0; i < lines.length; i++)
	if (lines[i] != null)
	  {
	    if (!hn.equalsIgnoreCase(lines[i]))
	      fdataout.println(lines[i]);
	  }
	try
	  {
	    fdataout.close();
	    fdatain.close();
	    fout.close();
	    fin.close();
	  }
	catch (IOException e){};
	
	CompData COMP;
	CompHist HIST;
	for( int i = 0; i < Server.comp_vector.size(); i++)
	  {
	    COMP = (CompData) Server.comp_vector.elementAt(i);
	    if (COMP.get_name().equalsIgnoreCase(hostName))
	      {
		Server.comp_vector.removeElementAt(i);
		System.out.println("removed from vector   : "+hostName);
	      }
	  }
	for( int i = 0; i < Server.hist_vector.size(); i++)
	  {
	    HIST = (CompHist) Server.hist_vector.elementAt(i);
	    if (HIST.get_name().equalsIgnoreCase(hostName))
	      {
		Server.hist_vector.removeElementAt(i);
		System.out.println("removed from hist vector   : "+hostName);
	      }
	  }
	


    }


  public static void main(String a[])
    {
      // (new ConfigFile()).remove("Stack.uni-mb.si linux");
    }
  
}
