import java.awt.*;

public class Dialog1 extends Dialog
{
	
	public Dialog1(Frame parent, boolean modal, MTool  par)
	{
	  super(parent, modal);
	  this.parent = par;
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(insets().left + insets().right + 255,insets().top + insets().bottom + 144);
		label1 = new java.awt.Label("Username");
		label1.setBounds(insets().left + 24,insets().top + 36,66,24);
		add(label1);
		label2 = new java.awt.Label("Password");
		label2.setBounds(insets().left + 24,insets().top + 72,66,24);
		add(label2);
		textField1 = new java.awt.TextField();
		textField1.setBounds(insets().left + 114,insets().top + 30,82,30);
		add(textField1);
		textField2 = new java.awt.TextField();
		textField2.setEchoChar('*');
		textField2.setBounds(insets().left + 114,insets().top + 66,82,30);
		add(textField2);
		button1 = new java.awt.Button();
		button1.setActionCommand("button");
		button1.setLabel("OK");
		button1.setBounds(insets().left + 96,insets().top + 114,54,22);
		button1.setBackground(new Color(12632256));
		add(button1);
		setTitle("User Identification");
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		//}}
		textField1.setBackground(Color.white);
		textField2.setBackground(Color.white);
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public Dialog1(Frame parent, String title, boolean modal)
	{
		this(parent, modal, (MTool) parent);
		setTitle(title);
	}

	public synchronized void show()
	{
		Rectangle bounds = getParent().bounds();
		Rectangle abounds = bounds();

		move(bounds.x + (bounds.width - abounds.width)/ 2,
			 bounds.y + (bounds.height - abounds.height)/2);

		super.show();
	}

	//{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.TextField textField1;
	java.awt.TextField textField2;
	java.awt.Button button1;
	//}}
  MTool parent;
    
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == Dialog1.this)
				Dialog1_WindowClosing(event);
		}
	}
	
	void Dialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		//hide();
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_Action(event);
		}
	}

	void button1_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Disable the Dialog
		if (checkIdentity())
		{
		    hide();
		    parent.rearange(); 
		    parent.rearange();
		}
		//}}
	}
	
	private boolean checkIdentity()
	{
	    if ( textField1.getText().equals("user") && 
	    textField2.getText().equals("user"))
	    return true;
	    return false;
	}
}
