import java.awt.*;
import java.util.*;

class ErrorCanvas extends Canvas
{
   
 Image image;
 Dimension d;
 Font f, fm ;
 int X,Y;
 StringTokenizer st ;
 String errors, str;
 Vector vector = new Vector();
 boolean debug = false;
 
 
 public  ErrorCanvas (String g)
     {
      d = this.size();
      setBackground (Color.lightGray);
      errors = g;
      f = new Font ("Helvetica", Font.PLAIN, 12);
      st = new StringTokenizer (errors,"|");
      repaint();
      while (st.hasMoreTokens())
	  {
	   str = st.nextToken();
	   vector.addElement(str);
	  }		
     }	

 public  ErrorCanvas (String g, Image i)
     {
      image = i ;
      d = this.size();
      setBackground (Color.lightGray);
      errors = g;
      f = new Font ("Helvetica", Font.PLAIN, 12);
      st = new StringTokenizer (errors,"|");
      repaint();
      while (st.hasMoreTokens())
	  {
	   str = st.nextToken();
	   vector.addElement(str);
	  }		
     }	

 
   public void paint (Graphics g)
     {
	String s;
	
	d = this.size();
	g.setFont (f);
	g.setColor(new Color(149,149,149));
	//g.setColor(Color.gray);
	g.fillRect(0,0,d.width,d.height);
	if ( image != null) 
	  g.drawImage(image,10,40,this);
	g.setFont (f);
	g.setColor(Color.black);
	for ( int i = 0; i < vector.size(); i++)
	  {
	   s = (String) vector.elementAt(i);
	   if(debug) System.out.println("V canvasu + "+s);
	   
	   if (i == 0) 
	       {
		g.drawString(s,70, 50);
		g.setColor(Color.white);
	       }	
	   else
	       {	
		g.drawString(s,70, 50+20*i);
	       }
	   
	  }

     }	


 public void pass_image ( Image i)
     {	
      image = i;
     }	
 
 
   public void update (Graphics g)
     {
      paint(g);
     }
   
}
