import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Panel;


public class InfoTipManager
{
    private static Panel infoTipPanel;

    public static Panel getInfoTipPanel()
    {
        if(infoTipPanel == null)
        {
            infoTipPanel = new Panel();
            infoTipPanel.hide();
            infoTipPanel.setLayout(null);
        }

        return infoTipPanel;
    }

    public static void draw(int x, int y, String s, FontMetrics fm, Color bc, Color fc)
    {
        infoTipPanel.reshape(x, y, fm.stringWidth(s), fm.getHeight());
        infoTipPanel.setBackground(bc);
        infoTipPanel.setForeground(fc);
        infoTipPanel.show();
    }
}
