
import java.awt.*;
import java.io.*;
import java.util.*;


public class MTool extends Frame
{
	public MTool()
	{
		
		setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(getInsets().left + getInsets().right + 394,getInsets().top + getInsets().bottom + 134);
		setBackground(new Color(-8415569));
		openFileDialog1 = new java.awt.FileDialog(this);
		openFileDialog1.setMode(FileDialog.LOAD);
		openFileDialog1.setTitle("Open");
		//$$ openFileDialog1.move(40,277);
		setTitle("MTool");
		//}}

		//{{INIT_MENUS
		mainMenuBar = new java.awt.MenuBar();
		menu1 = new java.awt.Menu("File");
		menuItem4 = new java.awt.MenuItem("Preferences");
		menu1.add(menuItem4);
		miExit = new java.awt.MenuItem("Exit");
		menu1.add(miExit);
		mainMenuBar.add(menu1);
		menu2 = new java.awt.Menu("Hosts");
		menuItem1 = new java.awt.MenuItem("Add Host");
		menu2.add(menuItem1);
		menuItem2 = new java.awt.MenuItem("Remove Host");
		menu2.add(menuItem2);
		//menuItem3 = new java.awt.MenuItem("Rescan Configuration");
		//menu2.add(menuItem3);
		mainMenuBar.add(menu2);
		menu3 = new java.awt.Menu("Help");
		mainMenuBar.setHelpMenu(menu3);
		miAbout = new java.awt.MenuItem("About..");
		menu3.add(miAbout);
		mainMenuBar.add(menu3);
		setMenuBar(mainMenuBar);
		//$$ mainMenuBar.move(4,277);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		miAbout.addActionListener(lSymAction);
		miExit.addActionListener(lSymAction);
		menuItem1.addActionListener(lSymAction);
		menuItem2.addActionListener(lSymAction);
		//menuItem3.addActionListener(lSymAction);
		menuItem4.addActionListener(lSymAction);
		//}}
		

		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);
		
		SymFocus aSymFocus = new SymFocus();
		this.addFocusListener(aSymFocus);

		
		imageCanvas = new ImageCanvas();
		Dimension d = this.getSize();
		imageCanvas.setX(300);
		//Show the  Username and Password Dialog
		//(new Dialog1(this, true, this )).show();
		load_images();
		messages.show();
		messages.toBack();
		aboutImage = (Image) ht_comp_images.get("about");
		CompInfo tmp;
		add("Center",imageCanvas);
		imageCanvas.repaint();

	}

	
public MTool(Hashtable ht)
	{
		
		setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(getInsets().left + getInsets().right + 394,getInsets().top + getInsets().bottom + 134);
		setBackground(new Color(-8415569));
		openFileDialog1 = new java.awt.FileDialog(this);
		openFileDialog1.setMode(FileDialog.LOAD);
		openFileDialog1.setTitle("Open");
		//$$ openFileDialog1.move(40,277);
		setTitle("MTool");
		//}}

		//{{INIT_MENUS
		mainMenuBar = new java.awt.MenuBar();
		menu1 = new java.awt.Menu("File");
		menuItem4 = new java.awt.MenuItem("Preferences");
		menu1.add(menuItem4);
		miExit = new java.awt.MenuItem("Exit");
		menu1.add(miExit);
		mainMenuBar.add(menu1);
		menu2 = new java.awt.Menu("Hosts");
		menuItem1 = new java.awt.MenuItem("Add Host");
		menu2.add(menuItem1);
		menuItem2 = new java.awt.MenuItem("Remove Host");
		menu2.add(menuItem2);
		//menuItem3 = new java.awt.MenuItem("Rescan Configuration");
		//menu2.add(menuItem3);
		mainMenuBar.add(menu2);
		menu3 = new java.awt.Menu("Help");
		mainMenuBar.setHelpMenu(menu3);
		miAbout = new java.awt.MenuItem("About..");
		menu3.add(miAbout);
		mainMenuBar.add(menu3);
		setMenuBar(mainMenuBar);
		//$$ mainMenuBar.move(4,277);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		miAbout.addActionListener(lSymAction);
		miExit.addActionListener(lSymAction);
		menuItem1.addActionListener(lSymAction);
		menuItem2.addActionListener(lSymAction);
		//menuItem3.addActionListener(lSymAction);
		menuItem4.addActionListener(lSymAction);
		//}}

		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);

		ht_comp_images = ht;
		imageCanvas = new ImageCanvas();
		Dimension d = this.getSize();
		imageCanvas.setX(300);
		//Show the  Username and Password Dialog
		//(new Dialog1(this, true, this )).show();
		messages.show();
		messages.toBack();
		aboutImage = (Image) ht_comp_images.get("about");
		CompInfo tmp;
		add("Center",imageCanvas);
		imageCanvas.repaint();

	}


  public MTool(String title)
	{
		this();
		setTitle(title);
	}

	public synchronized void show()
	{
		setLocation(50, 50);
		super.show();
	}

	static public void main(String args[])
	{

	  (new MTool()).show();
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the getInsets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.FileDialog openFileDialog1;
	//}}

	//{{DECLARE_MENUS
	java.awt.MenuBar mainMenuBar;
	java.awt.Menu menu1;
	java.awt.MenuItem menuItem4;
	java.awt.MenuItem miExit;
	java.awt.Menu menu2;
	java.awt.MenuItem menuItem1;
	java.awt.MenuItem menuItem2;
  //java.awt.MenuItem menuItem3;
	java.awt.Menu menu3;
	java.awt.MenuItem miAbout;
	//}}


  class SymFocus extends java.awt.event.FocusAdapter
        {
                public void focusGained(java.awt.event.FocusEvent event)
                {
                        Object object = event.getSource();
                        if (object == MTool.this)
                                Frame1_GotFocus(event);
                }
        }

        void Frame1_GotFocus(java.awt.event.FocusEvent event)
        {
                // to do: code goes here.
	  rearange();

                //{{CONNECTION
                // Repaint the Frame
                repaint();

                //}}
        }




  class SymComponent extends java.awt.event.ComponentAdapter
  {
    public void componentResized(java.awt.event.ComponentEvent event)
      {
	Object object = event.getSource();
	if (object == MTool.this)
	  ImageCanvas_ComponentResized(event);
      }
  }
  
  void ImageCanvas_ComponentResized(java.awt.event.ComponentEvent event)
    {
      // to do: code goes here.
      rearange();
    }


	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == MTool.this)
				Frame1_WindowClosing(event);
		}
	}

	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
		dispose();	  // free the system resources
		System.exit(0); // close the application
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == miAbout)
				miAbout_Action(event);
			else if (object == miExit)
				miExit_Action(event);
			else if (object == menuItem1)
				menuItem1_Action(event);
			else if (object == menuItem2)
				menuItem2_Action(event);
			//else if (object == menuItem3)
			//	menuItem3_Action(event);
			else if (object == menuItem4)
				menuItem4_Action(event);
		}
	}
	
	void miAbout_Action(java.awt.event.ActionEvent event)
	{
		//{{CONNECTION
		// Action from About Create and show as modal
	  (new AboutMtool(this,true,aboutImage)).show();
	}

	void miExit_Action(java.awt.event.ActionEvent event)
	{
		//{{CONNECTION
		// Action from Exit Create and show as modal
		(new QuitDialog(this, true)).show();
		//}}
	}

	void miOpen_Action(java.awt.event.ActionEvent event)
	{
		//{{CONNECTION
		// Action from Open... Show the OpenFileDialog
		openFileDialog1.show();
		//}}
	}

	void menuItem1_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
	  (new AddHostDialog(this,true)).show();
		//{{CONNECTION
		// Repaint the Frame
		repaint();
		//}}
	}

	void menuItem2_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		
	  (new RemoveHostDialog(this,"Remove Host", true)).show();
		//{{CONNECTION
		// Repaint the Frame
		repaint();
		get_all_hosts();
		//}}
	}

	void menuItem3_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Repaint the Frame
		repaint();
		CompVector.dump();
		//}}
	}

  public void rearange()
    {
      Dimension d = this.getSize();
      imageCanvas.setX(d.width);
      repaint();
      imageCanvas.rearange();
      imageCanvas.repaint();
    }

 public void get_all_hosts ()
  {
    String line;
    String line2,line3;

    compVector.removeAllElements();
    try
      {
	client = new GetData(Preferences.getServerName(),Preferences.getServerPort());
      }
    catch (IOException e )
      {

	Messages.addText(e.toString());
      }
    if ( client != null)
      {
	if (client.isConnected())
	  {
	    line = client.get_line();
	    Messages.addText(line);
	    line = client.get_line();
	    Messages.addText(line);
	    client.write("GET_ALL");
	    Messages.addText("GET_ALL ");

	    while ( (line = client.get_line()) != null)
	      {
		if (line.equalsIgnoreCase("END_ALL"))
		  break;
		line2 = client.get_line();
		line3 = client.get_line();		
		if (line2.equalsIgnoreCase("END_ALL"))
		  break;
		if (line3.equalsIgnoreCase("END_ALL"))
		  break;
		
		Messages.addText(line+" " +line2);
		if (line2.equalsIgnoreCase("linux"))
		  compVector.addComp(new CompInfo(line,CompInfo.LINUX ,(Image) ht_comp_images.get("linux"),line3 ));
		if (line2.equalsIgnoreCase("solaris"))
		  compVector.addComp(new CompInfo(line,CompInfo.SOLARIS ,(Image) ht_comp_images.get("sun"),line3 ));    
		if (line2.equalsIgnoreCase("hp-ux"))
		  compVector.addComp(new CompInfo(line,CompInfo.HPUX ,(Image) ht_comp_images.get("hp"),line3 ));
		if (line2.equalsIgnoreCase("windows"))
		  compVector.addComp(new CompInfo(line,CompInfo.WINDOWS ,(Image) ht_comp_images.get("win95"),line3 ));
		
  }
	    
	
	  }
	client.write("bye");
	client.disconnect();
	client = null;
	Messages.addText("odklopil All");
      }
    /*    Dimension d = this.getSize();
    imageCanvas.setX(d.width);
    imageCanvas.repaint();
   
    this.setSize(d.width+4,d.height+4);*/
    checkAllHosts.checkIt();
    rearange();
  }

  
  void load_images()
    {
      Image image = Toolkit.getDefaultToolkit().getImage("linux.gif");
      ht_comp_images.put("linux", image);
      image = Toolkit.getDefaultToolkit().getImage("sun.gif");
      ht_comp_images.put("sun", image);
      image = Toolkit.getDefaultToolkit().getImage("hp.gif");         
      ht_comp_images.put("hp", image);
      image = Toolkit.getDefaultToolkit().getImage("win95.gif");              
      ht_comp_images.put("win95", image);
      image = Toolkit.getDefaultToolkit().getImage("mtool2.jpg");              
      ht_comp_images.put("about", image);

    }

  public void pass_ht(Hashtable ht)
    {
      Messages.addText("Velikost hashtabele podane"+ht.size());
      ht_comp_images = ht;
      Messages.addText("Velikost hashtabele po podanju "+ht_comp_images.size());
    }

void set_false_state(String name)
    {


    
}


  private ImageCanvas imageCanvas ;
  private Hashtable ht_comp_images = new Hashtable();
  //  Vector compVector;
  
  private  GetData client;
  public static Messages messages = new Messages();
  public static Preferences prefs = new Preferences();
  public static CompVector compVector = new CompVector();
  CheckAllHosts checkAllHosts = new CheckAllHosts();
  Image aboutImage;

	void menuItem4_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
	  (new PrefDialog(this,true)).show();

		//{{CONNECTION
		// Repaint the Frame
		repaint();
		//}}
	}
}

